module qsort_c_to_fortran
      use iso_c_binding
      integer, parameter :: sp = selected_real_kind(6)
      interface
          subroutine qsort(a,n,size_a,compare_fun)  bind(c)
             use iso_c_binding
             type(c_ptr), value :: a
             integer(c_size_t), value :: n
             integer(c_size_t), value :: size_a
             type(c_funptr), value :: compare_fun
          end subroutine qsort
      end interface
   contains
     function compare_reals(a,b) bind(c)
         integer(c_int) :: compare_reals
         real(c_float) :: a,b
         if(a>b) then 
             compare_reals=1
         else if(a<b) then
             compare_reals=-1
         else
             compare_reals=0
         endif
     end function compare_reals
end module qsort_c_to_fortran

program test_qsort_c

    use qsort_c_to_fortran
    
    integer(c_size_t), parameter :: n=7
    real(c_float), pointer :: a(:) 
    
    allocate(a(n))
    call random_number(a)
    print*,'Unordered a: '
    print*,a
    
    call qsort(c_loc(a(1)), n, c_sizeof(a(1)), c_funloc(compare_reals));
    
    print*,'Ordered a: '
    print*,a

end program test_qsort_c
